dialog SLM {
  title "Lagmeter v3.0 - By [|Enter|]"
  size -1 -1 110 132
  option dbu
  check "Open lagmeter on mirc connect.", 1, 6 11 88 10
  button "Cancel", 2, 70 108 27 10, ok
  button "Apply", 3, 17 108 26 10
  box "Lagmeter update interval", 6, 3 51 107 39
  edit "2", 7, 7 77 99 10, autohs center
  text "Your lag meter will update every ? seconds:", 8, 7 60 99 16
  box "Startup Options", 9, 3 2 107 34
  check "Randomize color scheme", 10, 6 22 71 10
  button "Defaults", 12, 43 108 27 10
  button "Launch", 14, 30 94 54 10
  edit "", 15, 2 121 107 10, read autohs
  check "Enable custom color scheme", 4, 6 39 79 10
}

dialog ColorPicker {
  title "Color Picker - By [|Enter|]"
  size -1 -1 116 102
  option dbu
  button "Cancel", 2, 70 77 27 10, ok
  button "Apply", 3, 17 77 26 10
  button "Defaults", 12, 43 77 27 10
  button "Show Color Window", 14, 31 63 54 10
  edit "", 15, 2 90 111 10, read autohs
  box "Color Stats", 1, 2 17 112 42
  edit "", 4, 84 24 26 10, read autohs center
  text "Red", 5, 6 26 12 8
  scroll "", 6, 24 26 58 6, range 1 255 horizontal bottom
  edit "", 7, 84 35 26 10, read autohs center
  scroll "", 8, 24 37 58 6, range 1 255 horizontal bottom
  text "Green", 9, 6 37 16 8
  edit "", 10, 84 46 26 10, read autohs center
  scroll "", 11, 24 48 58 6, range 1 255 horizontal bottom
  text "Blue", 13, 6 48 12 8
  combo 16, 30 4 82 50, size drop
  text "Choose:", 17, 5 6 23 8
}

menu status,channel {
  Lag Meter v3.0-\=-
  .Open:dialog -mav SLM SLM 
}
menu @Lagmeter-* {
  rclick:/dialog -mav SLM SLM
}
on 1:dialog:ColorPicker:scroll:6: {
  if ($window(@ColorPicker)) {
    set %SLM. $+ $server $+ .REd $did(ColorPicker,6).sel
    did -i Colorpicker 4 1 %SLM. [ $+ [ $server ] $+ .Red ]
    updatecolor
  }
  else {
    window -pk0 +L @ColorPicker -1 -1 90 90
  }
}
on 1:dialog:ColorPicker:scroll:8: {
  if ($window(@ColorPicker)) {
    set %SLM. $+ $server $+ .Green $did(ColorPicker,8).sel
    did -i Colorpicker 7 1 %SLM. [ $+ [ $server ] $+ .Green ]
    updatecolor
  }
  else {
    window -pk0 +L @ColorPicker -1 -1 90 90
  }
}
on 1:dialog:ColorPicker:scroll:11: {
  if ($window(@ColorPicker)) {
    set %SLM. $+ $server $+ .Blue $did(ColorPicker,11).sel
    did -i Colorpicker 10 1 %SLM. [ $+ [ $server ] $+ .Blue ]
    updatecolor
  }
  else {
    window -pk0 +L @ColorPicker -1 -1 90 90
  }
}
on 1:dialog:ColorPicker:init:0: {
  /did -o colorpicker 16 1 BackGround
  /did -o colorpicker 16 2 Text
  /did -o colorpicker 16 3 Shadow
}
on 1:dialog:ColorPicker:sclick:3: {
  /did -o colorpicker 15 1 Saving Color Settings.
  if ($did(colorpicker,16).text == $null) {
    /did -o colorpicker 15 1 You must select a Aspect to change.
    halt
  }
  if ($did(colorpicker,16).text == BackGround) { 
    /set %SLM. $+ $server $+ .Custback $did(colorpicker,4).text $+ , $+ $did(colorpicker,7).text $+ , $+ $did(colorpicker,10).text
    /did -o colorpicker 15 1 The $did(colorpicker,16).text color has been set: $did(colorpicker,4).text $+ , $+ $did(colorpicker,7).text $+ , $+ $did(colorpicker,10).text
  }
  if ($did(colorpicker,16).text == Text) {
    /set %SLM. $+ $server $+ .Custtext $did(colorpicker,4).text $+ , $+ $did(colorpicker,7).text $+ , $+ $did(colorpicker,10).text
    /did -o colorpicker 15 1 The $did(colorpicker,16).text color has been set: $did(colorpicker,4).text $+ , $+ $did(colorpicker,7).text $+ , $+ $did(colorpicker,10).text
  }
  if ($did(colorpicker,16).text == Shadow) {
    /set %SLM. $+ $server $+ .Custshadow $did(colorpicker,4).text $+ , $+ $did(colorpicker,7).text $+ , $+ $did(colorpicker,10).text 
    /did -o colorpicker 15 1 The $did(colorpicker,16).text color has been set: $did(colorpicker,4).text $+ , $+ $did(colorpicker,7).text $+ , $+ $did(colorpicker,10).text
  }
}
alias updatecolor {
  drawrect -rf @ColorPicker $rgb(%SLM. [ $+ [ $server ] $+ .Red ],%SLM. [ $+ [ $server ] $+ .Green ],%SLM. [ $+ [ $server ] $+ .Blue ]) 2 0 0 90 90
}
on 1:dialog:ColorPicker:sclick:14: {
  window -pk0 +L @ColorPicker -1 -1 90 90
}
on 1:dialog:colorpicker:close:0: {
  if (@colorpicker) {
    /close -@ @colorpicker
  }
}
on 1:dialog:SLM:sclick:4: {
  if ($did(SLM,4).state = 1) { 
    dialog -mav ColorPicker ColorPicker
  }
}
on 1:dialog:SLM:sclick:3: {
  did -i SLM 15 1 Saving Settings.
  set %SLM. $+ $server $+ .start $did(SLM,1).state
  set %SLM. $+ $server $+ .duration $did(SLM,7).text
  if ($did(SLM,4).state == 1) { 
    did -u SLM 10
    set %SLM. $+ $server $+ .randcolor 2
  }
  else {
    set %SLM. $+ $server $+ .randcolor $did(SLM,10).state 
  }
  .timer 1 1 did -i SLM 15 1 Successfully Saved Settings.
}
alias Checkstate {
  if ($appstate == tray) { close -@ $+(@Lagmeter-,$server) | halt }
  else { 
    if ($window($+(@Lagmeter-,$server))) {
      return
    }
    else { Load.Lagmeter start }
  }
}

on 1:dialog:SLM:sclick:14: {
  If ($status == Disconnected) { /did -i SLM 15 1 You are not connected to the mirc. Connect then try again. | halt }
  if (%SLM. [ $+ [ $server ] $+ .state ] == 0) { 
    did -i SLM 14 1 Disable
    window -pdhk0o +dL @Lagmeter- $+ $Server 503 42 260 20
    Startping
    .timerstatecheck off
    .timerstatecheck -m 0 100 /Checkstate
    Load.Lagmeter Start
    halt
  }
  else {
    Load.Lagmeter Stop
  }
}
alias DrawLagmeterRandomColor {
  window -pdhk0o +deL @Lagmeter- $+ $Server 503 42 260 20
  drawrect -f $+(@Lagmeter-,$Server) %SLM. [ $+ [ $server ] $+ .randback  ] 2 0 0 260 20
  drawrect -f $+(@Lagmeter-,$Server) %SLM. [ $+ [ $server ] $+ .randshadow ] 2 2 2 254 14
}
alias DrawLagmeterCustomColor {
  window -pdhk0o +deL @Lagmeter- $+ $Server 503 42 260 20
  drawrect -rf $+(@Lagmeter-,$Server) $rgb( [ %SLM. [ $+ [ $server ] $+ .custback ] ] ) 2 0 0 260 20
  drawrect -rf $+(@Lagmeter-,$Server) $rgb( [ %SLM. [ $+ [ $server ] $+ .custshadow ] ] ) $+ ) 2 2 2 254 14
}
alias DrawLagmeter {
  window -pdhk0o +deL @Lagmeter- $+ $Server 503 42 260 20
  drawrect -f $+(@Lagmeter-,$Server) 15 2 0 0 260 20
  drawrect -f $+(@Lagmeter-,$Server) 14 2 2 2 254 14
}
alias Load.Lagmeter {
  if ($1 == Start) { goto next1 }
  elseif ($1 == Continue) { goto next2 }
  else { goto next3 }
  :next1
  if (%SLM. [ $+ [ $server ] $+ .randcolor ] = 1) { 
    DrawLagmeterRandomColor
    set %SLM. $+ $server $+ .state 1    
    .timerduration 0 %SLM. [ $+ [ $server ] $+ .duration ] .ping $me
    Startping
  }
  elseif (%SLM. [ $+ [ $server ] $+ .randcolor ] = 2) {
    DrawLagmeterCustomColor
    set %SLM. $+ $server $+ .state 1    
    .timerduration 0 %SLM. [ $+ [ $server ] $+ .duration ] .ping $me
    Startping
  }
  else {
    DrawLagmeter
    set %SLM. $+ $server $+ .state 1
    .timerduration 0 %SLM. [ $+ [ $server ] $+ .duration ] .ping $me
    Startping
  }
  halt
  :next2
  if (%SLM. [ $+ [ $server ] $+ .randcolor ] = 1) { 
    .timerduration 0 %SLM. [ $+ [ $server ] $+ .duration ] .ping $me
    halt
  }
  elseif (%SLM. [ $+ [ $server ] $+ .randcolor ] = 2) {
    .timerduration 0 %SLM. [ $+ [ $server ] $+ .duration ] .ping $me
    halt
  }
  else {
    .timerduration 0 %SLM. [ $+ [ $server ] $+ .duration ] .ping $me
    halt  
  }
  :next3
  set %SLM. $+ $server $+ .state 0
  if ($window($+(@Lagmeter-,$server))) {
    if ($dialog(SLM)) { did -i SLM 14 1 Launch }
  }
  else { return }
  .timerDuration off
  .timerstatecheck off
  window -c @Lagmeter- [ $+ [ $Server ] ]
  halt
}
alias Startping {
  if (%SLM. [ $+ [ $server ] $+ .randcolor ] == 1) {
    drawtext -o $+(@Lagmeter-,$Server) %SLM. [ $+ [ $server ] $+ .Randtext ] arial 10 8 2 Awaiting reply..
  }
  elseif (%SLM. [ $+ [ $server ] $+ .randcolor ] = 2) {
    drawtext -ro $+(@Lagmeter-,$Server) $rgb( [ %SLM. [ $+ [ $server ] $+ .custtext ] ] ) arial 10 8 2 Awaiting reply..
  }
  else {
    drawtext -o $+(@Lagmeter-,$Server) 0 arial 10 8 2 Awaiting reply..
  }
  .ping $me
}
on *:CTCPREPLY:PING*:{
  if ($nick == $me) {
    if ($window($+(@Lagmeter-,$Server))) {
      if (%SLM. [ $+ [ $server ] $+ .randcolor ] == 1) {
        DrawLagmeterRandomColor
        if ($len( $+ $nopath( $+ " $+ $server $+ " $+ ) $+ ) > 27) { 
          drawtext -o $+(@Lagmeter-,$server) %SLM. [ $+ [ $server ] $+ .randtext ] arial 10 8 2 Server: $left($nopath( $+ " $+ $server $+ " $+ ),20) $+ ... - Lag: $calc($ctime - $2) $+ Secs 
        }
        else {
          /did -o entpla 6 1 $nopath(%entpla.filelocation)
        }
        .timerduration off   
        Load.Lagmeter Continue    
      }
      elseif (%SLM. [ $+ [ $server ] $+ .randcolor ] = 2) {
        DrawLagmeterCustomColor
        if ($len( $+ $nopath( $+ " $+ $server $+ " $+ ) $+ ) > 27) { 
          drawtext -o $+(@Lagmeter-,$server) %SLM. [ $+ [ $server ] $+ .custtext ] arial 10 8 2 Server: $left($nopath( $+ " $+ $server $+ " $+ ),20) $+ ... - Lag: $calc($ctime - $2) $+ Secs 
        }
        else {
          /did -o entpla 6 1 $nopath(%entpla.filelocation)
        }

        .timerduration off   
        Load.Lagmeter Continue
      }
      else { 
        DrawLagmeter
        if ($len( $+ $nopath( $+ " $+ $server $+ " $+ ) $+ ) > 27) { 
          drawtext -o $+(@Lagmeter-,$server) 0 arial 10 8 2 Server: $left($nopath( $+ " $+ $server $+ " $+ ),20) $+ ... - Lag: $calc($ctime - $2) $+ Secs 
        }
        else {
          /did -o entpla 6 1 $nopath(%entpla.filelocation)
        }

        .timerduration off   
        Load.Lagmeter Continue 
      }
    }
  }
  halt
}
on 1:DISCONNECT:{
  Load.lagmeter stop
}
on 1:CONNECT:{
  If (%SLM. [ $+ [ $server ] $+ .start ] = 1) { 
    if (%SLM. [ $+ [ $server ] $+ .randcolor ] == 1) {
      set %SLM. $+ $server $+ .Randtext $rand(0,15)
      set %SLM. $+ $server $+ .Randback $rand(0,15)
      set %SLM. $+ $server $+ .Randshadow $rand(0,15)
    }
    .timerstatecheck off
    .timerstatecheck -m 0 100 Checkstate
    load.lagmeter start
    startping
  }
  else { return }
}
on 1:LOAD:{
  echo Performing one-time initialization Lagmeter v3.0
  set %SLM. $+ $server $+ .randcolor 0
  set %SLM. $+ $server $+ .start 1
  set %SLM. [ $+ [ $server ] $+ .state ] 0
  set %SLM. [ $+ [ $server ] $+ .state ] 1
  set %SLM. [ $+ [ $server ] $+ .duration ] 10
  .timerInit 1 1 echo Initialization For Lagmeter v3.0 3Complete $+ ...
}
on 1:CLOSE: $+ $+(@Lagmeter-,$server) $+ :{
  Load.Lagmeter Stop
}
on 1:dialog:SLM:init:0: {
  If ($status == Disconnected) { /did -i SLM 15 1 Offline. | halt }
  if (%SLM. [ $+ [ $server ] $+ .state ] = 1) { did -i SLM 14 1 Disable }
  else { did -i SLM 14 1 Launch }
  if (%SLM. [ $+ [ $server ] $+ .start ] = 1) { did -c SLM 1 }
  if (%SLM. [ $+ [ $server ] $+ .randcolor ] = 1) { did -c SLM 10 }
  if (%SLM. [ $+ [ $server ] $+ .randcolor ] = 2) { did -u SLM 10 | did -c SLM 4 }
  if (%SLM. [ $+ [ $server ] $+ .duration ] != $null) { did -i SLM 7 1 %SLM. [ $+ [ $server ] $+ .duration ] }
  else { set %SLM. [ $+ [ $server ] $+ .duration ] 10 | did -i SLM 7 1 %SLM. [ $+ [ $server ] $+ .duration ] }
}
on 1:dialog:SLM:sclick:13: {
  did -i SLM 15 1 Setting Defaults.
  set %SLM. $+ $server $+ .state 0
  set %SLM. $+ $server $+ .start 1
  set %SLM. $+ $server $+ .randcolor 0
  set %SLM. $+ $server $+ .duration 10
  did -i SLM 7 1 %SLM. [ $+ [ $server ] $+ .duration ]
  set %SLM. $+ $server $+ .Randtext $rand(0,15)
  set %SLM. $+ $server $+ .Randback $rand(0,15)
  set %SLM. $+ $server $+ .Randshadow $rand(0,15)
  set %SLM. [ $+ [ $server ] $+ .PingReply ] 5
  .timer 1 1 did -i SLM 15 1 Defaults have been reset.
}
raw 409:*: { 
  haltdef
}
